//freeware by Joe Nodeland jnodeland@dccnet.com
//feel free to let me know how you use this package.
unit fDetail;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Mask,  ExtCtrls, Buttons,
  ToolWin,  DBTables, DBCtrls, Db, 
    uConstants;

CONST
  MSG_REQUIREDFIELDS = 'An event name and phone number are required';
  
type
  TfrmDetail = class(TForm)
    Panel1: TPanel;
    lblTitle: TLabel;
    Image1: TImage;
    ToolBar1: TToolBar;
    spdHelp: TSpeedButton;
    spdExit: TSpeedButton;
    qryDetail: TQuery;
    pageMain: TPageControl;
    tabDetail: TTabSheet;
    btnSave: TSpeedButton;
    btnCancel: TSpeedButton;
    btnPhone: TSpeedButton;
    Label52: TLabel;
    dateCalStart: TDateTimePicker;
    Label53: TLabel;
    dateCalStop: TDateTimePicker;
    Label54: TLabel;
    edtLength: TDBEdit;
    Label1: TLabel;
    Label3: TLabel;
    Label2: TLabel;
    srcDetail: TDataSource;
    DBEdit1: TDBEdit;
    edtPhoneNum: TDBEdit;
    DBComboBox1: TDBComboBox;
    Label4: TLabel;
    Label5: TLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure spdExitClick(Sender: TObject);
    procedure DataChange(Sender: TObject);
    procedure qryDetailBeforePost(DataSet: TDataSet);
    procedure qryDetailAfterCancel(DataSet: TDataSet);
    procedure qryDetailAfterPost(DataSet: TDataSet);
    procedure srcDetailStateChange(Sender: TObject);
    procedure btnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure qryDetailAfterInsert(DataSet: TDataSet);
    procedure edtLengthChange(Sender: TObject);
    procedure dateCalStartChange(Sender: TObject);
    procedure btnPhoneClick(Sender: TObject);
    procedure dateCalStopChange(Sender: TObject);
  private
    bPopulating:Boolean;
    bRecordChanged:Boolean;
    bInserting :Boolean;
    procedure PopulateControls;
    function GetLength: Double;
    function SetLength(Start,Stop:TDateTime):Double;
    function GetStopTime:  TDateTime;
    procedure CopyEventData(CopyId:Integer);
  public


  end;

//var
  //frmDetail: TfrmDetail;
function ShowfrmDetail(Id,CopyId:Integer;ResourceId:String; Start,Stop:TDateTime):Boolean;

implementation
 uses fMain, dmain ;
      
{$R *.DFM}
function ShowfrmDetail(Id, CopyId: Integer;ResourceId:String; Start,Stop:TDateTime):Boolean;
begin
  Result:=False;
  Screen.Cursor := crHourglass;
  With TfrmDetail.Create(Application) do
  Try
    With qryDetail do begin
      Params[0].asInteger := Id;
      open;
      If Fields[0].isNull then begin
        Insert;
        FieldByName('ResourceId').asString:=ResourceId;
        FieldByName('StartDate').asDateTime := Start;
        FieldByName('EndDate').asDateTime := Stop;
        FieldByName('BackColor').asInteger := 1;
        FieldByName('FontColor').asInteger := clBlack;
      end;
      If Id = gCOPY then CopyEventData(CopyId)     //paste from a copy command
      else if CopyId = CUT then begin             //paste from a cut command
        Edit;
        FieldByName('ResourceId').asString:=ResourceId;
        FieldByName('StartDate').asDateTime := Start;
        FieldByName('EndDate').asDateTime := Stop;
      end;
      bInserting := (State = dsInsert);
      PopulateControls;
    end;  
    ShowModal;
    result := bRecordChanged;
    qryDetail.Close;
  Finally
    Screen.Cursor := crDefault;
    Release;
  End;  
end;

procedure TfrmDetail.FormShow(Sender: TObject);
begin
Try
  pageMain.ActivePage := tabDetail;
  With qryDetail do
   lblTitle.Caption
   := FormatDateTime('dd mmm yyyy ddd hh:nn am/pm',FieldByName('Startdate').asDatetime)
   +  '   ' + FieldByName('NameId').asString
   +  '   ' + FieldByName('ResourceId').asString;
Finally
  Screen.Cursor := crDefault;
End;
end;

procedure TfrmDetail.FormClose(Sender: TObject; var Action: TCloseAction);
var  b:boolean;
begin
  With qryDetail do
  Try
    If Active and (State in [dsEdit,dsInsert]) then Post;
    If qryDetail.Active and qryDetail.UpdatesPending then
      dmMain.Database1.ApplyUpdates([qryDetail]);
  Except on E:Exception do begin
      MessageDlg(e.message,mtWarning,[mbOK],0);
      If e.message = MSG_REQUIREDFIELDS then
        Action := caNone;
    end;
  End;
end;

procedure TfrmDetail.PopulateControls;
begin
  With qryDetail do
  Try
    bPopulating := True;
    edtLength.Text :=
      FloatToStr(SetLength(FieldByName('StartDate').asDateTime,FieldByName('EndDate').asDateTime));
    DateCalStart.DateTime := FieldByName('StartDate').asDateTime;
    DateCalStop.DateTime := FieldByName('EndDate').asDateTime;

  Finally
    bPopulating := False;
  End;
end;

//------------- private events ---------------------------

procedure TfrmDetail.CopyEventData(CopyId:Integer);
var i:Integer;
begin
  With dmMain, dmMain.qryTemp do
  Try
    sql.Text := 'select * from events where id = :eventid';
    Params[0].asInteger := CopyId;
    Open;
    For i := 0 to FieldCount - 1 do
      If (Fields[i].FieldName <> 'Id')
      and (Fields[i].FieldName <> 'ResourceId')
      and (Fields[i].FieldName <> 'StartDate')
      and (Fields[i].FieldName <> 'EndDate') then
        qryDetail.Fields[i].Value := Fields[i].Value;
      qryDetail.FieldByName('EndDate').asDateTime :=FieldByName('EndDate').asDateTime
      -FieldByName('StartDate').asDateTime + qryDetail.FieldByName('StartDate').asDateTime;

  Finally
    Close;
  End;
end;

//------------- control events ---------------------------
procedure TfrmDetail.spdExitClick(Sender: TObject);
begin
  Close;
end;


//------------------ data access -------------------------

procedure TfrmDetail.DataChange(Sender: TObject);
begin
  If not bPopulating and(qryDetail.State in [dsBrowse]) then begin
    qryDetail.Edit;
  end;
end;

procedure TfrmDetail.qryDetailBeforePost(DataSet: TDataSet);
begin
  With dataset do begin
    If FieldbyName('NameID').isNull or FieldbyName('PhoneNumber').isNull then begin
      raise Exception.Create(MSG_REQUIREDfIELDS);
    end;
  end;
end;

procedure TfrmDetail.qryDetailAfterCancel(DataSet: TDataSet);
begin
  If bInserting then Close
  else PopulateControls;
end;

procedure TfrmDetail.qryDetailAfterPost(DataSet: TDataSet);
begin
  bRecordChanged := True;
end;

//--------------- time manipulation routines -------------------------

//round length to correct fraction of hour defined by dmMain.configuration.interval
function TfrmDetail.GetLength: Double;
var Interval, JobLength:Double;
begin
  With qryDetail do begin
    JobLength := StrToFloat(edtLength.Text);
    Interval := dmMain.Configuration.Interval / 60; { = .25, .5, or 1}
    Result := (Round(JobLength / Interval) * Interval);
    Result := JobLength;
  end;
end;

function TfrmDetail.SetLength(Start,Stop:TDateTime):Double;
var Interval:Double;
begin
  Interval := dmMain.Configuration.Interval / 1440;
  Result := Round((Frac(Stop) - Frac(Start))/(Interval)) *(dmMain.Configuration.Interval / 60) ;
end;

function TfrmDetail.GetStopTime:  TDateTime;
begin
  Result := qryDetail.FieldByName('StartDate').asDateTime
            + (GetLength / 24)
            - (1 / 1440);  // subtract one minute
end;

//-------------- end time stuff ----------------------------

procedure TfrmDetail.srcDetailStateChange(Sender: TObject);
begin
  With qryDetail do begin
    btnCancel.Enabled := (qryDetail.State in [dsEdit,dsInsert]);
    btnSave.Enabled := btnCancel.Enabled;
  end;
end;

procedure TfrmDetail.btnClick(Sender: TObject);
begin
  If (qryDetail.State in [dsInsert,dsEdit]) then begin
    If (sender = btnCancel) then qryDetail.Cancel
    else if (sender = btnSave) then qryDetail.Post;
  end;
  Try
    If qryDetail.Active and qryDetail.UpdatesPending then
      dmMain.Database1.ApplyUpdates([qryDetail]);
  Except on e:exception do
    MessageDlg(e.message,mtError,[mbOK],0);
  End;
end;



procedure TfrmDetail.qryDetailAfterInsert(DataSet: TDataSet);
var i:Integer;
begin
  With Dataset, dmMain do begin
    For i := 0 to FieldCount - 1 do begin
      If Fields[i].DataType
      in [ftSmallint, ftInteger, ftWord, ftBoolean, ftFloat, ftCurrency] then
        Fields[i].AsInteger := 0;
    end;
    //qryDetail['id'] := ????; //identity field - database dependent
    FieldbyName('CreateDate').asDateTime := Now;
    FieldByName('BackColor').asInteger := 1;
   end;
end;

procedure TfrmDetail.edtLengthChange(Sender: TObject);
begin

end;

//actual start/stop times
procedure TfrmDetail.dateCalStartChange(Sender: TObject);
begin
  If not bPopulating  then  with qryDetail do begin
    If (State in [dsBrowse]) then Edit;
    fieldByName('StartDate').asDateTime := DateCalStart.DateTime;
  end;
end;

//actual start/stop times
procedure TfrmDetail.dateCalStopChange(Sender: TObject);
begin
  If not bPopulating  then  with qryDetail do begin
    If (State in [dsBrowse]) then Edit;
    fieldByName('EndDate').asDateTime := DateCalStop.DateTime;
  end;
end;

procedure TfrmDetail.btnPhoneClick(Sender: TObject);
var phonenum, who:String;
begin
  dmMain.DialPhone(edtPhonenum.Text,who);
end;

end.





