//freeware by Joe Nodeland jnodeland@dccnet.com
//feel free to let me know how you use this package.
unit fMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
   Forms, Dialogs, CustomSched, StdCtrls, ExtCtrls, 
  RowCal, ComCtrls, Menus, ImgList, Db, DBTables, DBCtrls,
  uConstants,  Buttons;

Type
  TfrmMain = class(TForm)
    StatusBar: TStatusBar;
    mnu: TMainMenu;
    mnuDayView: TPopupMenu;
    mnuFilterResources: TMenuItem;
    mnuExit: TMenuItem;
    mnuDayNew: TMenuItem;
    mnuDayEdit: TMenuItem;
    mnuDayDelete: TMenuItem;
    qryEvents: TQuery;
    Maintenance1: TMenuItem;
    mnuGroupBy: TMenuItem;
    mnuGroupbyDate: TMenuItem;
    mnuGroupByResource: TMenuItem;
    mnuPrint: TMenuItem;
    mnuConfigure: TMenuItem;
    Splitter2: TSplitter;
    mnuResourceAvail: TMenuItem;
    mnuBreak: TMenuItem;
    mnuDispatch: TMenuItem;
    mnuTrucks: TMenuItem;
    mnuResourcesShow: TMenuItem;
    mnuTrucksSearch: TMenuItem;
    mnuComplete: TMenuItem;
    Panel1: TPanel;
    Panel2: TPanel;
    btnMonthDown: TSpeedButton;
    btnMonthUp: TSpeedButton;
    mnuBooked: TMenuItem;
    tmrRowCal: TTimer;
    mnuCut: TMenuItem;
    mnuCopy: TMenuItem;
    mnuPaste: TMenuItem;
    N3: TMenuItem;
    qryResourceSched: TQuery;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure RowCalChange(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure RowCalKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure mnuDayNewClick(Sender: TObject);
    procedure RowCalDblClick(Sender: TObject);
    procedure MainMenuClick(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure btnMonthUpClick(Sender: TObject);
    procedure tmrRowCalTimer(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private

    procedure DayViewClick(Sender: TObject);
    procedure DayViewKeyUp(Sender: TObject; var Key: Word;
                           Shift: TShiftState);
    procedure EventDroppedBeforeUpdate(Sender: TObject; EventId: Longint;
                  OriginalStartDate:TDateTime; var OKToMove:Boolean);
    procedure EventDroppedAfterUpdate(Sender: TObject; EventId: Longint;
                           OriginalStartDate, DroppedStartDate:TDateTime);
  public
    RowCal: TRowCal;
    DayView: TjwDayView;
    CutCopy_EventId:Integer;  //id of event being cut, copied, or pasted
   end;

var
  frmMain: TfrmMain;
implementation

{$R *.DFM}
uses dMain, fDetail, fResourcesFilter;

procedure TfrmMain.FormCreate(Sender: TObject);
var h :THandle;
begin
  RowCal := TRowCal.Create(Self);
  RowCal.Parent := Panel1;
  RowCal.Align := alClient;
  RowCal.Visible := True;
  RowCal.OnChange := RowCalChange;
  RowCal.OnKeyUp := RowCalKeyUp;
  
  DayView := TjwDayView.Create(Self);
  with DayView do begin
    Parent := Self;
    font:=TForm(parent).font;
    hourStart:= dmMain.Configuration.StartHour;
    hourend := dmMain.Configuration.EndHour;
    Interval := dmMain.Configuration.Interval;
    Align := alClient;
    PopupMenu := mnuDayView;
    DateRange.add(Pointer(Trunc(Date)));
    dmMain.qryResource.Open;
    While not dmMain.qryResource.eof do begin
      DayView.ResourceRange.add(dmMain.qryResource.Fieldbyname('ResourceId').asString);
      dmMain.qryResource.Next;
    end;
    dmMain.qryResource.Close;
    Query := qryEvents;                  //qry that gets scheduled events
    ResourceQuery := qryResourceSched;   //qry that gets resource status
    FieldID         := 'Id';             //Name of field for unique record id
    FieldResourceId := 'ResourceId';     //name of field for event resourceid
    FieldStart      := 'StartDate';      //name of field for event starttime
    FieldEnd        := 'EndDate';        //name of field for event endtime
    ConfigureGrid;
    OnClick := DayViewClick;
    OnDblClick := RowCalDblClick;
    OnKeyUp := DayViewKeyUp;
    OnEventDroppedBeforeUpdate := EventDroppedBeforeUpdate;
    OnEventDroppedAfterUpdate  := EventDroppedAfterUpdate;
    visible := true;
  end;
  h := LoadImage(0,pchar(ExtractFilePath(Application.EXEName) +
                   '\' + 'select.cur'),image_cursor,0,0,
                 lr_defaultsize or lr_loadfromfile);
  If h <> 0 then Screen.Cursors[crhandPoint] := h;
  RowCalChange(tmrRowCal);
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
              
end;

//------------- private events ---------------------------

//--------------------- form controls ------------------------------

//use this timer to prevent multiple queries being generated when user uses arrows
//to navigate left and right on the calendar
procedure TfrmMain.tmrRowCalTimer(Sender: TObject);
begin
  tmrRowCal.Enabled := False;
  RowCalChange(tmrRowCal);
end;

procedure TfrmMain.RowCalChange(Sender: TObject);
var i:Integer;
begin
  If sender = tmrRowCal then begin
    DayView.DateRange.Clear;
    For i := 0 to RowCal.SelectedDates.Count - 1 do
      DayView.DateRange.add(Pointer(StrToInt(RowCal.SelectedDates[i])));
    DayView.ConfigureGrid;
  end
  else begin
    tmrRowCal.Enabled := False;
    tmrRowCal.Enabled := True;
  end;
end;

procedure TfrmMain.RowCalKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  Case key of
    38:If RowCal.Row = 1 then RowCal.PrevMonth;
    40:If RowCal.Row = RowCal.RowCount -1 then Rowcal.NextMonth ;
   end ;
end;

procedure TfrmMain.DayViewKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  Case key of
    vk_Return :RowCalDblClick(nil);
    vk_Escape :Screen.Cursor := crDefault;
   end ;
end;

procedure TfrmMain.mnuDayNewClick(Sender: TObject);
var EventId: Integer;
    ResourceId:String;
    start,stop: TDateTime;
begin
  If Sender = mnuDayNew then RowCalDblClick(nil)
  else if Sender = mnuDayEdit then RowCalDblClick(nil)
  else if Sender = mnuDayDelete then begin
    DayView.GetEventId(EventId);
    With dmMain.qryTemp do
    Try
      sql.text := 'Delete from events where id = :id';
      params[0].asInteger := EventId;
      ExecSql;
      DayView.ConfigureGrid;
    Except on e:Exception do
      MessageDlg(e.message,mtError,[mbOK],0);
    End;
  end
  else if Sender = mnuDispatch then begin
    DayView.GetEventId(EventId);
    With qryEvents do
    If Locate('Id',EventId,[]) then
    Try
      DayView.EventList.EventSetState(EventId,0);
      DayView.EventList.ReDrawEvent(EventId);
    Except on e:Exception do
      MessageDlg(e.message,mtError,[mbOK],0);
    End;
  end
  else if Sender = mnuBooked then begin
    DayView.GetEventId(EventId);
    With qryEvents do
    If Locate('Id',EventId,[]) then
    Try
      DayView.EventList.EventSetState(EventId,1);
      DayView.EventList.ReDrawEvent(EventId);
    Except on e:Exception do
      MessageDlg(e.message,mtError,[mbOK],0);
    End;
  end
  else if Sender = mnuComplete then begin
    DayView.GetEventId(EventId);
    With qryEvents do
    If Locate('Id',EventId,[]) then
    Try
      DayView.EventList.EventSetState(EventId,2);
      DayView.EventList.ReDrawEvent(EventId);
    Except on e:Exception do
      MessageDlg(e.message,mtError,[mbOK],0);
    End;
  end
  else if sender = mnuCopy then begin
    DayView.GetEventId(CutCopy_EventId);
    If qryEvents.Locate('Id',CutCopy_EventId,[]) then begin
      mnuPaste.Enabled := (CutCopy_EventId <> - 1);
      mnuPaste.Tag := gCOPY;
    end
    else mnuPaste.Enabled := False;
  end
  else if sender = mnuCut then begin
    DayView.GetEventId(CutCopy_EventId);
    If qryEvents.Locate('Id',CutCopy_EventId,[]) then begin
      mnuPaste.Enabled := (CutCopy_EventId <> - 1);
      mnuPaste.Tag := CUT;
    end
    else mnuPaste.Enabled := False;
  end
  else if sender = mnuPaste then begin
    DayView.GetData(Resourceid, Start, Stop);
    If mnuPaste.Tag = CUT then begin
      ShowfrmDetail(CutCopy_EventId, CUT, ResourceId, Start, Stop);
      mnuPaste.Enabled := False;
    end
    else //COPY
      ShowfrmDetail(gCOPY, CutCopy_EventId, ResourceId, Start, Stop);
    DayView.ConfigureGrid;
  end;
end;

procedure TfrmMain.RowCalDblClick(Sender: TObject);
var start,stop: TDateTime;
    Resourceid: String;
    EventId:Integer;
begin
    EventId := NEW;
    DayView.GetEventId(EventId);
    StatusBar.SimpleText := DayView.Information;
    //if new
    If EventId = NEW then begin
      DayView.GetData(Resourceid,Start,Stop);
      if ShowfrmDetail(NEW,0, ResourceId, Start, Stop) then
        DayView.ConfigureGrid;
    end
    //else existing
    else if ShowfrmDetail(EventId,0, '', 0, 0) then begin
      DayView.ConfigureGrid;
    end;
end;

procedure TfrmMain.DayViewClick(Sender: TObject);
var EventId:Integer;
    sText:String;
begin
  DayView.GetEventId(EventId);
  DayView.BuildDisplayLine(sText);
  DayView.EventList.EventSetText(EventId,sText);
  StatusBar.SimpleText := DayView.Information;
end;

procedure TfrmMain.MainMenuClick(Sender: TObject);
begin
  If Sender = mnuExit then Close
  else if sender = mnuFilterResources  then begin
    If ShowfrmResourcesFilter(dmMain.qryResource,DayView.ResourceRange) then
      DayView.ConfigureGrid;
  end    
  else if (sender = mnuGroupByDate)and (not mnuGroupbyDate.Checked) then begin
    mnuGroupByDate.Checked := True;
    mnuGroupByResource.Checked := False;
    DayView.GroupBy := gbDate;
    DayView.ConfigureGrid;
  end
  else if (sender = mnuGroupByResource)and (not mnuGroupbyResource.Checked) then begin
    mnuGroupByResource.Checked := True;
    mnuGroupByDate.Checked := False;
    DayView.GroupBy := gbResource;
    DayView.ConfigureGrid;
  end
  else if sender = mnuResourcesShow then
    ShowMessage('Show form for modifying information about the resource'
               +#13#10 + 'See table "Resources"')
  else if sender = mnuResourceAvail then
    ShowMessage('Show form for modifying resource status by date.'
               +#13#10 + 'See table "ResourceSched"')
  else if sender = mnuConfigure then
    ShowMessage('Show form for modifying schedule format.'
               +#13#10 + 'See table "Configuration"')  ;
end;

//timer is set when authorized users want to edit read only fields
//expires after 15 minutes
procedure TfrmMain.TimerTimer(Sender: TObject);
begin

end;

//================= when an event has been dragged check if update needed
// the following 2 events are initiated in TCustomSched.dragdrop
procedure TfrmMain.EventDroppedBeforeUpdate(Sender: TObject; EventId: Longint;
                   OriginalStartDate:TDateTime; var OKToMove:Boolean);
begin
  OKToMove := True;
  //OKToMove := Some Logic;
  if not OKToMove then Exit;
  Try
   // If not dmMain.Database1.InTransaction then dmMain.Database1.StartTransaction;

  Except
    OKToMove := False;
   // If dmMain.Database1.InTransaction then dmMain.Database1.Rollback;
  End;
end;

procedure TfrmMain.EventDroppedAfterUpdate(Sender: TObject; EventId: Longint;
                              OriginalStartDate, DroppedStartDate:TDateTime);
begin
  //if the event has been dragged to the same day period
  If Trunc(OriginalStartDate) = Trunc(DroppedStartDate) then begin
   // If dmMain.Database1.InTransaction then dmMain.Database1.Commit;
    exit;
  end
  else//event has been dragged to a new date
 // If not dmMain.Database1.InTransaction then dmMain.Database1.StartTransaction;
  With qryEvents, dmMain do
  Try
    
   // If Database1.InTransaction then Database1.Commit;
  Except
   // If Database1.InTransaction then Database1.Rollback;
  End;
end;

procedure TfrmMain.btnMonthUpClick(Sender: TObject);
begin
    If sender = btnMonthUp then
      If RowCal.Row = 1 then RowCal.PrevMonth;
    If sender = btnMonthdown then
      If RowCal.Row = RowCal.RowCount -1 then Rowcal.NextMonth ;
end;



procedure TfrmMain.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := False;
  Showmessage('Start by highlighting a section of a column on the calendar,'
  + #13#10 + 'then right click and select the menu item "New"');
end;

end.
