//freeware by Joe Nodeland jnodeland@dccnet.com
//feel free to let me know how you use this package.
unit fResourcesFilter;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, ToolWin, ComCtrls, ExtCtrls, StdCtrls, CheckLst, db;

type
  TfrmFilterResources = class(TForm)
    Panel1: TPanel;
    lblTitle: TLabel;
    Image1: TImage;
    ToolBar1: TToolBar;
    spdHelp: TSpeedButton;
    spdExit: TSpeedButton;
    ScrollBox: TScrollBox;
    StatusBar1: TStatusBar;
    btnNone: TSpeedButton;
    btnAll: TSpeedButton;
    procedure FormShow(Sender: TObject);
    procedure spdExitClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CheckBoxClick(Sender: TObject);
    procedure btnClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    fSelectionChanged: Boolean;
    ResourceDataset: TDataset;
    SelectedList: TStringList;
  public
    { Public declarations }
  end;

//var
  //frmFilterResources: TfrmFilterResources;
  function ShowfrmResourcesFilter(aDataset:TDataset;aList:TStringList):Boolean;

implementation
{$R *.DFM}
uses dMain;

//-------------------- interface --------------------------------
function ShowfrmResourcesFilter(aDataset:TDataset; aList:TStringList):Boolean;
begin
  Result := False;
  With TfrmFilterResources.Create(Application) do
  Try
    ResourceDataset := aDataset;
    SelectedList := aList;
    fSelectionChanged := False;
    ShowModal;
    Result :=  fSelectionChanged;
  Finally
    Release;
  End;  
end;
//-------------------- form stuff -------------------------------
procedure TfrmFilterResources.FormShow(Sender: TObject);
var i, j: Integer;
    cb: TCheckBox;
begin
  i:= 0;
  With ResourceDataset do
  Try
    If not Active then Open;
    First;
    If fields[0].isNull then begin
      MessageDlg('There are no Resources in the database.' + #13#10
                +'Enter resources using the Utils/Resources '+ #13#10
                +'menu item on the main form.  ',mtWarning,[mbOK],0);
      Postmessage(handle,wm_close,0,0);
    end;
    While not eof do begin
      inc(i);
      cb := TCheckBox.Create(Self);
      cb.Parent := ScrollBox;
      cb.Caption := ResourceDataset.FieldByName('ResourceId').asString
      + ' (' +  ResourceDataset.FieldByName('ResourceType').asString + ')';
      cb.Left := 20;
      cb.Top := 30 * i;
      cb.Visible := True;
      For j := 0 to SelectedList.Count -1 do
        If SelectedList[j] = ResourceDataset['ResourceId'] then
          cb.Checked := True;
      cb.OnClick := CheckBoxClick;
      Next;
    end;
  Finally
    Close;
  End;
end;

procedure TfrmFilterResources.FormClose(Sender: TObject;
                                         var Action: TCloseAction);
var i:Integer;
begin
  If fSelectionChanged then
  With SelectedList do begin
    Clear;
    For i := 0 to ComponentCount - 1 do
      If (Components[i] is TCheckBox)
      and (TCheckBox(Components[i]).Checked) then begin
        Add(Trim(Copy(TCheckBox(Components[i]).Caption,1,Pos('(',TCheckBox(Components[i]).Caption)-1)));
      end;
  end;
end;
//------------------ control methods ----------------------

procedure TfrmFilterResources.spdExitClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmFilterResources.CheckBoxClick(Sender: TObject);
begin
  fSelectionChanged := True;
  
end;

procedure TfrmFilterResources.btnClick(Sender: TObject);
var bState: Boolean;
    i: Integer;
begin
  If Sender = btnAll then bState := True
  else if Sender = btnNone then bState := False
  else Exit;
  For i := 0 to ComponentCount - 1 do
    If (Components[i] is TCheckBox) then
      TCheckBox(Components[i]).Checked := bState;
end;

procedure TfrmFilterResources.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  dmMain.FormKeyDown(Sender,Key,Shift);
end;

end.
